package com.supwisdom.dlpay.framework.dao;

import com.supwisdom.dlpay.framework.domain.TVouchernoCtl;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;

@Repository
public interface VouchernoCtlDao extends JpaRepository<TVouchernoCtl, Integer> {
  @Query(value = "update TB_VOUCHERNOCTL set PERIOD_MONTH=:peridmonth,VOUCHERNO=:voucherno where VOUCHERTYPE=1 ", nativeQuery = true)
  void updateVoucherno(@Param("peridmonth") int peridmonth, @Param("voucherno") int voucherno);

  @Lock(LockModeType.PESSIMISTIC_FORCE_INCREMENT)
  @Query(value = "from TVouchernoCtl where vouchertype=1 ")
  TVouchernoCtl getVoucherno();
}
